/*-----------------------------------------------------------------------*/
/*  (C) Copyright Institute of Astronomy ETHZ 8092 Zuerich Switzerland   */
/*-----------------------------------------------------------------------*/
/*  Programmname: PlottUnit.cpp                                          */
/*                                                                       */
/*  Revision: V1.1     Date: 01.05.2007    Autor: Chr. Monstein          */
/*                                                                       */
/*  Purpose: Plott utility linear, logarithmic and 3D                    */
/*                                                                       */
/*  Compiler: BORLAND C++Builder 6                                       */
/*-----------------------------------------------------------------------*/

// Created by: Chr. Monstein 01.05.2007
// Updated by: Chr. Monstein 19.12.2012
// Updated by: Chr. Monstein 27.12.2012  multi plot (3)
//---------------------------------------------------------------------------
#pragma hdrstop

#include <math.h>
#include <stdio.h>
#include "dislin.h"
#include "PlottUnit.h"
#include "MyGlobal.h"
#include "mainunit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall TPlotter::TPlotter() // constructor
{
}
//---------------------------------------------------------------------------
void __fastcall TPlotter::Init(void) // Farben, Groesse, evtl. Position
{
    character_height   = 55;   // 60
}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetNumber(long _n) {Ni = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetTitle(char *_text) {title_text=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetSubTitle(char *_text) {sub_title_text=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetSubSubTitle(char *_text) {sub_sub_title_text=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetDevice(char *_dev) {device=_dev;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetXLabel(char *_text) {xlabel_text=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetXminmax(float _a, float _b, float _c)
{xmin=_a; xmax=_b; dx=_c;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYminmax(float _a, float _b, float _c)
{ymin=_a; ymax=_b; dy=_c;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetWindowCoordinates(int _a, int _b, int _c, int _d)
{
    win_width   = _a;
    win_height  = _b;
    win_x0      = _c;
    win_y0      = _d;
}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYLabel(char *_text) {ylabel_text=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetXvector(float *_x) {xarr = _x;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYvector1(float *_y) {yarr1 = _y;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYvector2(float *_y) {yarr2 = _y;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetYvector3(float *_y) {yarr3 = _y;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetThickness_Curve(int _n) {thick_curve = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetMarker(int _n) {mark = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetThickness_Marker(int _n) {thick_mark = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetColor1(char *_text) {color_curve1=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetColor2(char *_text) {color_curve2=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetColor3(char *_text) {color_curve3=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetFilename(char *_text) {filename=_text;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::SetBGColor(int _n) {color_bg = _n;}
//---------------------------------------------------------------------------
void __fastcall TPlotter::LinPlott(bool single) // lin
{
    if (!strstr(filename,".nil"))
    {
       setfil(filename);
       filmod("DELETE");
    }
    metafl(device); // XWIN or CONS or PDF
    window(win_x0,win_y0,win_width,win_height); // Fensterposition und -groesse in pixel x0, y0,w,h

    //scrmod("revers");
    disini(); // oeffnet fenster
    winmod("NONE"); // FULL, NONE (muss nicht quittiert werden), NOHOLD, NOERASE (blitzt nicht aber blockiert main), DELAY
    errmod("ALL","OFF");
    pagera(); // small border around the page

    pagfll(color_bg); // hintergrundfarbcode

    color("black");

    hwfont();  // Font
    height(character_height); // character height in pixels
    paghdr("NF.EXE","Callisto",1,1); // Randbeschriftung
    axspos(550,1800);       // position im Fenster
    axslen(2200,1500);      // Breite, Hhe =2/3 of page
    name(xlabel_text,"x");  // X-Label
    name(ylabel_text,"y");  // Y-label
    titlin(title_text,4);   // Main title

    messag(sub_title_text,615,400); // sub title
    messag(sub_sub_title_text,615,500); // sub sub title

    labdig(1,"x");        // Format x-axis float, 0=point, n=digits
    axsscl("LIN","y");    // y-Achse linear
    labdig(1,"y");        // nachkommastellen y-Achse
    hname(55);            // schriftgroesse Achsennamen
    labels("FLOAT","y");  // LOG-Format nur y-Label
    thkcrv(thick_curve);  // thickness curve
    marker(mark);         // marker symbol
    hsymbl(7*(thick_mark) - 1);   // thickness marker (system uses 6,13,20,...)
    incmrk(1);            // symbolabstaende in messpunkte

    graf(xmin,xmax,xmin,dx,ymin, ymax, ymin, dy);  // linear variabel
    title();
    if (strlen(color_curve1)<3)
      color("black");
    else
      color(color_curve1);
    curve(xarr,yarr1,Ni);

    if (!single)
    {
      color(color_curve2);
      curve(xarr,yarr2,Ni);

      color(color_curve3);
      curve(xarr,yarr3,Ni);
    }
    endgrf();
    disfin();
}
//---------------------------------------------------------------------------
void __fastcall TPlotter::Close()
{
   sendmb();  // right mouse click dislin
}
//---------------------------------------------------------------------------
__fastcall TPlotter::~TPlotter() // destructor
{
}
//---------------------------------------------------------------------------
