/*-----------------------------------------------------------------------*/
/*  (C) Copyright Institute of Astronomy ETHZ 8092 Zuerich Switzerland   */
/*-----------------------------------------------------------------------*/
/*  Programmname: VoltageUnit.cpp                                        */
/*                                                                       */
/*  Revision: V1.0     Date: 25.12.2012    Autor: Chr. Monstein          */
/*                                                                       */
/*  Purpose: Noise Figure Measurement of a CALLISTO                      */
/*                                                                       */
/*  Compiler: BORLAND C++Builder 6                                       */
/*-----------------------------------------------------------------------*/

// Created by: Chr. Monstein 25.12.2012
// Updated by: Chr. Monstein 25.12.2012
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "VoltageUnit.h"
#include "FCunit.h"
#include "mainunit.h"
#include "RXRS232.H"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
extern TWrite *RX_SerialThread; // RX activities
extern Byte RX_ringbuff[RXbuflen];
extern long RX_in, RX_out;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Timer1Timer(TObject *Sender) // read and display voltages
{
    static int state = 0;
    char ch;
    char st[80], data[RXbuflen];
    static int pwm, old_pwm=0;
    switch (state)
    {
       case 0:
       {
          RX_in  = 0;
          RX_out = 0;
          pwm = atoi(ieee->Edit3->Text.c_str());
          if (pwm <   1) pwm =  1;
          if (pwm > 255) pwm =255;
          if (pwm!=old_pwm)
          {
             sprintf(st,"O%03i\r",pwm); // set gain
             RX_SerialThread->Send(st);
             old_pwm = pwm;
          }
          state++;
          break;
       }
       case 1:
       {
          RX_SerialThread->Send("U6\r");
          state++;
          break;
       }
       case 2:
       {
          RX_SerialThread->Send("U4\r");
          state++;
          break;
       }
       case 3:
       {
          RX_SerialThread->Send("U2\r");
          state=0;
          break;
       }
    }

    int i = 0;
    do
    {
        ch = RX_ringbuff[RX_out];
        RX_out = (RX_out+1)%RXbuflen;
        if (ch==13) break;
        if (i>=(RXbuflen)) break; // emergeny exit
        data[i++] = ch;
    } while (1);
    data[i]='\0';

    if (strstr(data,"$CRX:AGC gain"))      Label1->Caption = data;
    if (strstr(data,"$CRX:Emitter BF199")) Label2->Caption = data;
    if (strstr(data,"$CRX:Analog Input"))  Label3->Caption = data;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormClose(TObject *Sender, TCloseAction &Action)
{
   Timer1->Enabled=false;
}
//---------------------------------------------------------------------------

