/*-----------------------------------------------------------------------*/
/*  (C) Copyright Institute of Astronomy ETHZ 8092 Zuerich Switzerland   */
/*-----------------------------------------------------------------------*/
/*  Programmname: mainunit.h                                             */
/*                                                                       */
/*  Revision: V1.0     Date: 05.05.2003    Autor: Chr. Monstein          */
/*                                                                       */
/*  Purpose: Noise Figure Measurement of a CALLISTO                      */
/*                                                                       */
/*  Compiler: BORLAND C++Builder 6                                       */
/*-----------------------------------------------------------------------*/

// Created by: Chr. Monstein 05.05.2003
// Updated by: Chr. Monstein 17.06.2003
// Updated by: Chr. Monstein 26.11.2004 programmable baudrate, integration deleted
// Updated by: Chr. Monstein 29.09.2012 improvements
// Updated by: Chr. Monstein 19.12.2012 memory management improved (pointer)

//---------------------------------------------------------------------------

#ifndef mainunitH
#define mainunitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CCALENDR.h"
#include <Grids.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class Tieee : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
    TButton *Button1;
    TButton *Button2;
    TTimer *Timer1;
    TLabel *Label4;
    TLabel *Label5;
        TEdit *Edit2;
        TLabel *Label10;
        TEdit *Edit3;
        TLabel *Label13;
        TButton *Button4;
        TRadioButton *RadioButton1;
        TRadioButton *RadioButton2;
        TRadioButton *RadioButton3;
        TEdit *Edit4;
        TEdit *Edit5;
        TLabel *Label16;
        TLabel *Label18;
        TEdit *Edit11;
        TLabel *Label27;
        TEdit *Edit12;
        TLabel *Label7;
        TGroupBox *GroupBox1;
        TLabel *Label17;
        TLabel *Label15;
        TLabel *Label21;
        TLabel *Label22;
        TLabel *Label23;
        TLabel *Label24;
        TLabel *Label25;
        TLabel *Label26;
        TLabel *Label8;
        TEdit *Edit7;
        TEdit *Edit8;
        TEdit *Edit9;
        TEdit *Edit10;
        TEdit *Edit13;
        TEdit *Edit14;
        TEdit *Edit6;
        TLabel *Label11;
        TEdit *Edit15;
        TLabel *Label9;
        TEdit *Edit16;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label6;
        TEdit *Edit17;
        TLabel *Label12;
        TLabel *Label14;
        TLabel *Label19;
        TRadioButton *RadioButton5;
        TRadioButton *RadioButton6;
        TRadioButton *RadioButton4;
        TRadioButton *RadioButton7;
        TEdit *Edit18;
        TLabel *Label20;
        TEdit *Edit19;
        TLabel *Label28;
        TProgressBar *ProgressBar1;
        TEdit *Edit20;
        TLabel *Label29;
        TLabel *Label30;
        TButton *Button6;
        TButton *Button7;
        TButton *Button8;
        TButton *Button9;
        TTimer *Timer2;
        TGroupBox *GroupBox2;
        TButton *Button5;
        TButton *Button3;
        TLabel *Label3;
        TEdit *Edit1;
        TButton *Button10;
        TTimer *Timer3;
        TButton *Button12;
        TCheckBox *CheckBox1;
        TMainMenu *DigitalOut;
        TMenuItem *Focus1;
        TMenuItem *Individual1;
        TMenuItem *Toggle1;
        TMenuItem *Sequence1;
        TMenuItem *Editnfcfg1;
        TMenuItem *Individual2;
        TMenuItem *Voltages1;
        TMenuItem *Editconfig1;
        TMenuItem *Showversioncontrol1;
        TMenuItem *Digitizer1;
        TLabel *Label31;
        TMenuItem *AGCtsting1;
        TTimer *Timer4;
        TButton *Button11;
        TMenuItem *AGCLIN1;
        TTimer *Timer5;
        TButton *Button13;
        TTimer *Timer6;
        TButton *Button14;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button5Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall ReadConfig(void);
        void __fastcall Button6Click(TObject *Sender);
        void __fastcall Button7Click(TObject *Sender);
        void __fastcall Button9Click(TObject *Sender);
        void __fastcall Timer2Timer(TObject *Sender);
        void __fastcall Button8Click(TObject *Sender);
        void __fastcall Button10Click(TObject *Sender);
        void __fastcall Timer3Timer(TObject *Sender);
        void __fastcall Button12Click(TObject *Sender);
        void __fastcall Individual1Click(TObject *Sender);
        void __fastcall Toggle1Click(TObject *Sender);
        void __fastcall Sequence1Click(TObject *Sender);
        void __fastcall Individual2Click(TObject *Sender);
        void __fastcall Voltages1Click(TObject *Sender);
        void __fastcall Editconfig1Click(TObject *Sender);
        void __fastcall Showversioncontrol1Click(TObject *Sender);
        void __fastcall Digitizer1Click(TObject *Sender);
        void __fastcall AGCtsting1Click(TObject *Sender);
        void __fastcall Timer4Timer(TObject *Sender);
        void __fastcall Button11Click(TObject *Sender);
        void __fastcall AGCLIN1Click(TObject *Sender);
        void __fastcall Timer5Timer(TObject *Sender);
        void __fastcall Button13Click(TObject *Sender);
        void __fastcall Timer6Timer(TObject *Sender);
        void __fastcall Button14Click(TObject *Sender);

private:	// Anwender-Deklarationen

public:		// Anwender-Deklarationen
    __fastcall Tieee(TComponent* Owner);
    __fastcall ~Tieee();
   void __fastcall OpenLogging(char *st);
   void __fastcall Logging(char *par);
   void __fastcall CloseLogging(void);
   void __fastcall Reset();
   void __fastcall Erase(); // erase measurement buffer

};
//---------------------------------------------------------------------------
extern PACKAGE Tieee *ieee;
typedef struct
{
  int switch_cold, switch_warm, switch_hot;
  char type_cold, type_warm, type_hot;
  float attenuator;
} Tswitch;
//---------------------------------------------------------------------------
#endif
